searchNodes=[{"doc":"Stargate provides an Elixir client for the Apache Pulsar distributed message log service, based on the Pulsar project's websocket API. Producer Create a producer process under your application's supervision tree with the following: options = [ name : :pulsar_app , host : [ { :&quot;broker-url.com&quot; , 8080 } ] , producer : [ persistence : &quot;non-persistent&quot; , tenant : &quot;marketing&quot; , namespace : &quot;public&quot; , topic : &quot;new-stuff&quot; ] ] Stargate.Supervisor . start_link ( options ) Once the producer is running, pass messages to the client by pid or by the named registry entry: Stargate . produce ( producer , [ { &quot;key&quot; , &quot;value&quot; } ] ) If you won't be producing frequently you can choose to run ad hoc produce commands against the url of the Pulsar cluster/topic as follows: url = &quot;ws://broker-url.com:8080/ws/v2/producer/non-persistent/marketing/public/new-stuff&quot; Stargate . produce ( url , [ { &quot;key, &quot; value &quot; } ] ) Consumer and Reader Both consumers and readers connected to Pulsar via Stargate process received messages the same way. Stargate takes care of receiving the messages and sending acknowledgements back to the cluster so all you need to do is start a process and define a module in your application that invokes use Stargate.Receiver.MessageHandler and has a handle_message/1 or handle_message/2 function as follows: defmodule Publicize.MessageHandler do use Stargate.Receiver.MessageHandler def handle_message ( %{ context : context , payload : payload } ) do publish_to_channel ( payload , context ) :ack end defp publish_to_channel ( payload , context ) do ... do stuff ... end end The handle_message/1 must return either :ack or :continue in order to ack successful processing of the message back to the cluster or continue processing without ack (in the event you want to do a bulk/cumulative ack at a later time). If using the handle_message/2 callback for handlers that keep state across messages handled, it must return {:ack, state} or {:continue, state} . Then, create a consumer or reader process under your application's supevision tree with the following: options = [ name : :pulsar_app , host : [ { :&quot;broker-url.com&quot; , 8080 } ] consumer : [ &lt;= === == replace with ` :reader ` for a reader client tenant : &quot;internal&quot; , namespace : &quot;research&quot; , topic : &quot;ready-to-release&quot; , subscription : &quot;rss-feed&quot; , &lt;= === == required for a ` :consumer ` handler : Publicizer.MessageHandler ] ] Stargate.Supervisor . start_link ( options ) Readers and Consumers share the same configuration API with the two key differences that the :consumer key in the options differentiates from the :reader key, as well as the requirement to provide a &quot;subscription&quot; to a consumer for the cluster to manage messages.","ref":"Stargate.html","title":"Stargate","type":"module"},{"doc":"See Stargate.Producer.produce/2 .","ref":"Stargate.html#produce/2","title":"Stargate.produce/2","type":"function"},{"doc":"See Stargate.Producer.produce/3 .","ref":"Stargate.html#produce/3","title":"Stargate.produce/3","type":"function"},{"doc":"Generate the via-tuple needed for addressing a process within the Stargate supervision tree. Expects at minimum the tenant, namespace, and topic of the process being addressed and assumes by default the desired process is the Producer of a persistent topic managed by the default supervisor/registry. iex&gt; Stargate.registry_key(&quot;foo&quot;, &quot;bar&quot;, &quot;baz&quot;) {:via, Registry, {:sg_reg_default, {:producer, &quot;persistent&quot;, &quot;foo&quot;, &quot;bar&quot;, &quot;baz&quot;}}} iex&gt; Stargate.registry_key(&quot;foo&quot;, &quot;bar&quot;, &quot;baz&quot;, registry: MyCustom.Registry, persistence: &quot;non-persistent&quot;, component: :producer_ack) {:via, Registry, {MyCustom.Registry, {:producer_ack, &quot;non-persistent&quot;, &quot;foo&quot;, &quot;bar&quot;, &quot;baz&quot;}}}","ref":"Stargate.html#registry_key/4","title":"Stargate.registry_key/4","type":"function"},{"doc":"","ref":"Stargate.html#t:component/0","title":"Stargate.component/0","type":"type"},{"doc":"","ref":"Stargate.html#t:key_opt/0","title":"Stargate.key_opt/0","type":"type"},{"doc":"","ref":"Stargate.html#t:namespace/0","title":"Stargate.namespace/0","type":"type"},{"doc":"","ref":"Stargate.html#t:persistence/0","title":"Stargate.persistence/0","type":"type"},{"doc":"","ref":"Stargate.html#t:tenant/0","title":"Stargate.tenant/0","type":"type"},{"doc":"","ref":"Stargate.html#t:topic/0","title":"Stargate.topic/0","type":"type"},{"doc":"Connection provides the core abstraction for the websocket connection between the client application and the Pulsar cluster shared by all Stargate producer, reader, and consumer processes.","ref":"Stargate.Connection.html","title":"Stargate.Connection","type":"module"},{"doc":"The Connection using macro provides the common websocket connection and keepalive functionality into a single line for replicating connection and ping/pong handling in a single place.","ref":"Stargate.Connection.html#__using__/1","title":"Stargate.Connection.__using__/1","type":"macro"},{"doc":"Parses the keyword list configuration passed to a websocket and constructs the authentication options, either SSL or token-based, to be passed to the websocket process.","ref":"Stargate.Connection.html#auth_settings/1","title":"Stargate.Connection.auth_settings/1","type":"function"},{"doc":"Parses the keyword list configuration passed to a websocket and constructs the url needed to establish a connection to the Pulsar cluster. If query params are provided, appends the connection-specific params string to the url and returns the full result as a map to pass to the connection start_link/1 function.","ref":"Stargate.Connection.html#connection_settings/3","title":"Stargate.Connection.connection_settings/3","type":"function"},{"doc":"","ref":"Stargate.Connection.html#t:connection_settings/0","title":"Stargate.Connection.connection_settings/0","type":"type"},{"doc":"This module provides the function to generate query parameters for establishing a consumer connection to a topic and subscription with Pulsar.","ref":"Stargate.Consumer.QueryParams.html","title":"Stargate.Consumer.QueryParams","type":"module"},{"doc":"Generates a query parameter string to append to the URL and path parameters when creating a Stargate.Receiver consumer connection. Stargate does not generate explicit query parameters for default values when not supplied by the calling application as Pulsar itself assumes default values when not supplied. Query parameters with nil values are removed from the resulting connection string so only those with explicit values will be passed to Pulsar when creating a connection.","ref":"Stargate.Consumer.QueryParams.html#build_params/1","title":"Stargate.Consumer.QueryParams.build_params/1","type":"function"},{"doc":"Defines the Elixir Struct that represents the structure of a Pulsar message. The struct combines the &quot;location&quot; data of the received messages (persistent vs. non-persistent, tenant, namespace, topic) with the payload, any key and/or properties provided with the message, and the publication timestamp as an DateTime struct, and the messageId assigned by the cluster. Example message = % Stargate.Message { topic : &quot;ready-for-release&quot; , namespace : &quot;research&quot; , tenant : &quot;internal&quot; , persistence : &quot;persistent&quot; , message_id : &quot;CAAQAw==&quot; , payload : &quot;Hello World&quot; , key : &quot;1234&quot; , properties : nil , publish_time : ~U[2020-01-10 18:13:34.443264Z] }","ref":"Stargate.Message.html","title":"Stargate.Message","type":"module"},{"doc":"Create a %Stargate.Message{} struct from a list of arguments. Takes the map decoded from the json message payload received from Pulsar and adds the tenant, namespace, topic, persistence information to maintain &quot;location awareness&quot; of a message's source topic. Creating a %Stargate.Message{} via the new/5 function automatically converts the ISO8601-formatted publish timestamp to a DateTime struct and decodes the message payload from the Base64 encoding received from the cluster.","ref":"Stargate.Message.html#new/5","title":"Stargate.Message.new/5","type":"function"},{"doc":"","ref":"Stargate.Message.html#t:t/0","title":"Stargate.Message.t/0","type":"type"},{"doc":"Provides a producer websocket process and functions for producing messages to the cluster. Pass a keyword list of configuration options to the start_link/1 function or simply call produce/2 passing a valid Pulsar producer URL in place of a producer process.","ref":"Stargate.Producer.html","title":"Stargate.Producer","type":"module"},{"doc":"Generate puid","ref":"Stargate.Producer.html#generate/0","title":"Stargate.Producer.generate/0","type":"function"},{"doc":"Puid.Info module info","ref":"Stargate.Producer.html#info/0","title":"Stargate.Producer.info/0","type":"function"},{"doc":"Produce a message or list of messages to the cluster by producer URL or producer process. Messages can be any of the accepted forms (see message type). Producing by URL is good for irregular and/or ad hoc producer needs that do not require a persistent websocket connection and ideally with few to no query parameters to configure producer options from the default. For higher volume producing, a persistent connection with an addressable producer process is recommended. Once the message(s) is produced, the calling process automatically blocks until it receives acknowledgement from the cluster that the message(s) has been received.","ref":"Stargate.Producer.html#produce/2","title":"Stargate.Producer.produce/2","type":"function"},{"doc":"Produce a list of messages to a Stargate producer process. Messages can be any of the accepted forms (see message type). When calling produce/3 the third argument must be an MFA tuple which is used by the producer's acknowledger process to asynchronously perform acknowledgement that the message was received by the cluster successfully. This is used to avoid blocking the calling process for performance reasons.","ref":"Stargate.Producer.html#produce/3","title":"Stargate.Producer.produce/3","type":"function"},{"doc":"Start a producer websocket process and link it to the current process. Producer options require, at minimum: * ` host ` is a tuple of the address or URL of the Pulsar cluster ( broker service ) and the port on which the service is exposed . * ` tenant ` is a string representing the tenant portion of the producer URL path parameter . * ` namespace ` is a string representing the namespace portion of the producer URL path parameter . * ` topic ` is a string representing the topic portion of the producer URL path parameter . * ` registry ` is the name of the process registry associated to the client &#39; s supervision tree . Stargate uses this to send messages back and forth between the producer and its acknowledger . Additional optional parameters to a producer are: * ` protocol ` can be one of &quot;ws&quot; or &quot;wss&quot; ; defaults to &quot;ws&quot; * ` persistence ` can be one of &quot;persistent&quot; or &quot;non-persistent&quot; per the Pulsar specification of topics as being in - memory only or persisted to the brokers &#39; disks . Defaults to &quot;persistent&quot; . * ` query_params ` is a map containing any or all of the following : * ` send_timeout ` the time at which a produce operation will time out ; defaults to 30 seconds * ` batch_enabled ` can be true or false to enable / disable the batching of messages . Defaults to &quot;false&quot; . * ` batch_max_msg ` defines the maximum number of messages in a batch ( if enabled ) . Defaults to 1000 . * ` max_pending_msg ` defines the maximum size of the internal queue holding messages . Defaults to 1000 . * ` batch_max_delay ` sets the time period within which message batches will be published . Defaults to 10 milliseconds . * ` routing_mode ` can be one of :round_robin or :single . _Pulsar has deprecated this parameter_ . * ` compression_type ` can be one of :lz4 , :zlib , or :none . Defaults to :none * ` name ` is used to enforce only one producer with the given name is publishing to connected topic . * ` initial_seq_id ` sets the baseline for the sequence ids assigned to published messages . * ` hashing_scheme ` can be one of :java_string or :murmur3 when defining a hashing function to use with partitioned topics . _Pulsar has deprecated this parameter_ . Note, the producer key of the supervisor config options will accept a list of producer configuration options to allow a single superviser to start and manage multiple producers. [ name : :my_app , host : [ { &quot;localhost&quot; , 8080 } ] , producer : [ [ persistence : &quot;persistent&quot; , tenant : &quot;na_sales&quot; , namespace : &quot;electronics&quot; , topic : &quot;events&quot; ] , [ persistence : &quot;persistent&quot; , tenant : &quot;eu_sales&quot; , namespace : &quot;textiles&quot; , topic : &quot;events&quot; ] ] ] While this is perfectly possible, you should carefully consider your supervision strategy and only group producers to different namespaces/tenants/topics/etc under a single supervisor where it makes sense to have the process lifecycle of each producer tightly linked to one another and consider the implications of a failure/death of one producer process on the others. Depending on your specific use case it is often equally if not more correct to have each unique producer under a dedicated supervisor, perhaps managed by a still higher-level supervisor in your own application. Plan accordingly based on your expected failure scenarios.","ref":"Stargate.Producer.html#start_link/1","title":"Stargate.Producer.start_link/1","type":"function"},{"doc":"Pulsar messages produced by Stargate can be any of the following forms: * raw binary payload ( must be encodable to base64 ) * a { key , value } tuple where key is the optional message key and value is the payload * a map with a &quot;payload&quot; field and optional fields for a key , context , properties ( key / value pairs as a map ) , and list of strings identifying replication clusters . Stargate uses the context field on a message produced to Pulsar to correlate receipt messages from the cluster to sent messages. If you do not define a context in your message, Stargate generates one automatically.","ref":"Stargate.Producer.html#t:message/0","title":"Stargate.Producer.message/0","type":"type"},{"doc":"A producer websocket process identified by a pid or via tuple. The atom key for identifying the producer in the via tuple is of the form :&quot;sg_prod_&lt;tenant&gt;_&lt;namespace&gt;_&lt;topic&gt; .","ref":"Stargate.Producer.html#t:producer/0","title":"Stargate.Producer.producer/0","type":"type"},{"doc":"A URL defining the host and topic to which a Stargate producer can connect for sending messages.","ref":"Stargate.Producer.html#t:url/0","title":"Stargate.Producer.url/0","type":"type"},{"doc":"By default, Stargate.produce/2 will block the calling process until acknowledgement is received from Pulsar that the message was successfully produced. This can optionally switch to an asynchronous acknowledgement by passing an MFA tuple to Stargate.produce/3 . This modules defines a GenServer process that works in tandem with a producer websocket connection to wait for and send receipt acknowledgements received from produce operations to the calling process or otherwise perform asynchronous acknowledgement operations.","ref":"Stargate.Producer.Acknowledger.html","title":"Stargate.Producer.Acknowledger","type":"module"},{"doc":"Sends a message to the acknowledger process to perform the ack operation saved for that particular message (as identified by the context sent with the message).","ref":"Stargate.Producer.Acknowledger.html#ack/2","title":"Stargate.Producer.Acknowledger.ack/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Stargate.Producer.Acknowledger.html#child_spec/1","title":"Stargate.Producer.Acknowledger.child_spec/1","type":"function"},{"doc":"Called by the producer when a message is produced to the Pulsar cluster. This function sends a message's context and the desired operation to perform for acknowledgement to the Acknowledger process to save in its state and act on when directed to acknowledge that message. Unless instructed otherwise by calling Stargate.produce/3 , Stargate.produce/2 assumes the third argument to be the PID of the calling process to send receipt confirmation and unblock.","ref":"Stargate.Producer.Acknowledger.html#produce/3","title":"Stargate.Producer.Acknowledger.produce/3","type":"function"},{"doc":"Starts a Stargate.Producer.Acknowledger process and link it to the calling process.","ref":"Stargate.Producer.Acknowledger.html#start_link/1","title":"Stargate.Producer.Acknowledger.start_link/1","type":"function"},{"doc":"This modules provides the function to generate query parameters for establishing a producer connection to a topic with Pulsar.","ref":"Stargate.Producer.QueryParams.html","title":"Stargate.Producer.QueryParams","type":"module"},{"doc":"Generates a query parameter string to apped to the URL and path parameters when creating a Stargate.Producer connection. Stargate does not generate explicit query parameters for default values when not supplied by the calling application as Pulsar itself assumes default values when not supplied. Query parameters with nil values are removed from the resulting connection string so only those with explicit values will be passed to Pulsar when creating a connection.","ref":"Stargate.Producer.QueryParams.html#build_params/1","title":"Stargate.Producer.QueryParams.build_params/1","type":"function"},{"doc":"Defines the state stored by the producer websocket process. The Stargate producer records the registry name associated to its supervision tree, the URL of the cluster and topic it connects to, as well as the individual components that make up the URL including the host, protocol (ws or wss), topic path parameters (persistent or non-persistent, tenant, namespace, and topic) and any query parameters configuring the connection.","ref":"Stargate.Producer.State.html","title":"Stargate.Producer.State","type":"module"},{"doc":"Creates and manages a supervisor process for the Stargate producer websocket process and acknowledger process.","ref":"Stargate.Producer.Supervisor.html","title":"Stargate.Producer.Supervisor","type":"module"},{"doc":"Generates a child specification for creating producer supervisor trees.","ref":"Stargate.Producer.Supervisor.html#child_spec/1","title":"Stargate.Producer.Supervisor.child_spec/1","type":"function"},{"doc":"Create a Stargate.Producer.Supervisor process and link it to the calling process. Passes the shared and :producer configurations from the top-level supervisor to the producer and acknowledger and starts them under a :one_for_one strategy.","ref":"Stargate.Producer.Supervisor.html#start_link/1","title":"Stargate.Producer.Supervisor.start_link/1","type":"function"},{"doc":"This module provides the function to generate query parameters for establishing a reader connection to a topic with Pulsar.","ref":"Stargate.Reader.QueryParams.html","title":"Stargate.Reader.QueryParams","type":"module"},{"doc":"Generates a query parameter string to apped to the URL and path parameters when creating a Stargate.Receiver reader connection. Stargate does not generate explicit query parameters for default values when not supplied by the calling application as Pulsar itself assumes default values when not supplied. Query parameters with nil values are removed from the resulting connection string so only those with explicit values will be passed to Pulsar when creating a connection.","ref":"Stargate.Reader.QueryParams.html#build_params/1","title":"Stargate.Reader.QueryParams.build_params/1","type":"function"},{"doc":"Provides a Stargate websocket process that can be either a reader or consumer connection based on the configuration passed when starting the process.","ref":"Stargate.Receiver.html","title":"Stargate.Receiver","type":"module"},{"doc":"Sends an acknowledgement of the given message ID back to the Pulsar cluster via the provided websocket process connection. This is required for all Stargate consumers and readers where acknowledgement signals the cluster to delete messages from the topic/subscription and send more while readers require acknowledgement to signal readiness for more messages.","ref":"Stargate.Receiver.html#ack/2","title":"Stargate.Receiver.ack/2","type":"function"},{"doc":"Sends a permit request to the Pulsar cluster via the provided websocket process connection. Used for consumers in pull mode to release up to the requested number of messages to be returned when available.","ref":"Stargate.Receiver.html#pull_permit/2","title":"Stargate.Receiver.pull_permit/2","type":"function"},{"doc":"Start a consumer or reader websocket process and link it to the current process. Consumer and Receiver options require, at minimum: * ` host ` is a tuple of the address or URL of the Pulsar cluster ( broker service ) and the port on which the service is exposed . * ` tenant ` is a string representing the tenant portion of the receiver URL path parameter . * ` namespace ` is a string representing the topic portion of the receiver URL path parameter . * ` topic ` is a string representing the topic portion of the receiver URL path parameter . * ` subscription ` ( for consumers ) is a string representing the subscription portion of the receiver URL path paramater . * ` registry ` is the name of the process registry associated to the client &#39; s supervision tee . Stargate uses this to subscribe to the stages of the receiver and to send messages back and forth between them . * ` handler ` is the name of the handler module that implements the ` Stargate.Receiver.MessageHandler ` behaviour . Additional optional parameters to a consumer and reader are: * ` protocol ` can be one of &quot;ws&quot; or &quot;wss&quot; ; defaults to &quot;ws&quot; . * ` persistence ` can be one of &quot;persistent&quot; orr &quot;non-persistent&quot; per the Pulsar specification of topics as being in - memory only or persisted to the brokers &#39; disks. Defaults to &quot;persistent&quot;. * `processors` is the number of GenStage processes in the &quot;processor&quot; stage to be created. This is the stage that performs the work of the message handler to perform processing logic on the received messages. Defaults to 1. * `handler_init_args` is any term that will be passed to the message handler to initialize its state when a stateful handler is desired. Defaults to an empty list. * `query_params` is a map containing any or all of the following: # Consumer * `ack_timeout` sets the timeout for unacked messages. Defaults to 0. * `subscription_type` can be one of `:exclusive`, `:failover`, or `:shared` to tell the Pulsar cluster if one or more consumers will be receiving messages on this topic and subscription. Defaults to exclusive. * `queue_size` sets the number of messages in the consumer&#39; s receive queue . Defaults to 1000 . * ` name ` registers a name for the consumer client with the Pulsar cluster . * ` priority ` sets the priority with the cluster for the consumer client to receive messages . * ` max_redeliver_count ` defines a maximum number of times to attempt redelivery of a message to the consumer before sending it to a dead letter queue . Activates the dead letter topic feature . * ` dead_letter_topic ` defines a name for a topic &#39;s corresponding dead letter topic. Activates the dead letter topic feature. Defaults to &quot;{topic}-{subscription}-DLQ&quot;. * `pull_mode` can be `true` or `false`. When a consumer is in pull mode, the cluster will hold messages on the subscription until it receives a permit request with an explicit number of desired messages to fulfill. # Reader * `name` registers a name for the reader client with the Pulsar cluster. * `queue_size` is the size of the queue maintained for the reader; defaults to 1000. * `starting_message` can be one of `:earliest`, `:latest`, or a message ID. Sets the reader&#39; s cursor to the desired message within the stream . Defaults to latest .","ref":"Stargate.Receiver.html#start_link/1","title":"Stargate.Receiver.start_link/1","type":"function"},{"doc":"A string identifier assigned to each message by the cluster","ref":"Stargate.Receiver.html#t:message_id/0","title":"Stargate.Receiver.message_id/0","type":"type"},{"doc":"Defines the Stargate.Receiver.Acknowledger GenStage process that acts as the final consumer in the receive pipeline to acknowledge successful processing of messages back to Pulsar to allow more messages to be sent and for the cluster to delete messages from the subscription in the case of consumers.","ref":"Stargate.Receiver.Acknowledger.html","title":"Stargate.Receiver.Acknowledger","type":"module"},{"doc":"Starts a Stargate.Receiver.Acknowledger process and links it to the calling process.","ref":"Stargate.Receiver.Acknowledger.html#start_link/1","title":"Stargate.Receiver.Acknowledger.start_link/1","type":"function"},{"doc":"Defines the struct used by a Stargate.Receiver.Acknowledger to store its state. Includes the type of the receiver (reader or consumer), the name of the process registry associated with the client supervision tree, the atom key of the receiver socket process within the process registry, and the path parameters of the topic connection (tenant, namespace, topic).","ref":"Stargate.Receiver.Acknowledger.State.html","title":"Stargate.Receiver.Acknowledger.State","type":"module"},{"doc":"Defines the Stargate.Receiver.Dispatcher GenStage process that functions as the producer in the pipeline, receiving messages pushed from the reader or consumer socket and dispatching to the rest of the pipeline.","ref":"Stargate.Receiver.Dispatcher.html","title":"Stargate.Receiver.Dispatcher","type":"module"},{"doc":"Push messages received over the reader or consumer connection into the GenStage processing pipeline for handling and acknowledgement. This is normally handled automatically by the websocket connection but can also be called directly for testing the receive pipeline.","ref":"Stargate.Receiver.Dispatcher.html#push/2","title":"Stargate.Receiver.Dispatcher.push/2","type":"function"},{"doc":"Starts a Stargate.Receiver.Dispatcher GenStage process and links it to the calling process.","ref":"Stargate.Receiver.Dispatcher.html#start_link/1","title":"Stargate.Receiver.Dispatcher.start_link/1","type":"function"},{"doc":"","ref":"Stargate.Receiver.Dispatcher.html#t:raw_message/0","title":"Stargate.Receiver.Dispatcher.raw_message/0","type":"type"},{"doc":"Defines the struct used by a Stargate.Receiver.Dispatcher to store its state. Includes the type of the receiver (consumer or reader), the name of the process registry associated to the supervision tree, the path parameters of the topic (tenant, namespace, topic), the atom key of the websocket connection within the process registry, and whether or not the receiver is in push or pull mode if it's consumer.","ref":"Stargate.Receiver.Dispatcher.State.html","title":"Stargate.Receiver.Dispatcher.State","type":"module"},{"doc":"Defines the MessageHandler behaviour required by a module passed to a Stargate reader or consumer. A message handler must implement a handle_message/1 for stateless message processing, and for stateful processing, a handle_message/2 and an init/1 function. This module also defines a __using__ macro to pull default implementations of these functions into your module as well as getter functions for the topic-aware data stored in the process dictionary of the Processor stage calling the message handler.","ref":"Stargate.Receiver.MessageHandler.html","title":"Stargate.Receiver.MessageHandler","type":"behaviour"},{"doc":"Provides a macro for implementing the behaviour in the client application's message handler module and automatically pull in default implementations of the required functions and getters for the data stored in the processor stage's process dictionary.","ref":"Stargate.Receiver.MessageHandler.html#__using__/1","title":"Stargate.Receiver.MessageHandler.__using__/1","type":"macro"},{"doc":"","ref":"Stargate.Receiver.MessageHandler.html#c:handle_message/1","title":"Stargate.Receiver.MessageHandler.handle_message/1","type":"callback"},{"doc":"","ref":"Stargate.Receiver.MessageHandler.html#c:handle_message/2","title":"Stargate.Receiver.MessageHandler.handle_message/2","type":"callback"},{"doc":"","ref":"Stargate.Receiver.MessageHandler.html#c:init/1","title":"Stargate.Receiver.MessageHandler.init/1","type":"callback"},{"doc":"Defines a Stargate.Receiver.Processor module as a GenStage process under the consumer or reader supervision tree. The processor stage performs the message handling step for all messages received on the connection by storing and calling the application's handler module on each message received. To better handle complex or long-running operations when handling messages, the processor stage can be scaled horizontally and takes care of the necessary subscriptions both upstream and downstream within the GenStage pipeline. During initialization, the processor stage stores several pieces of information in its process dictionary that are available to the application's message handler module when handling messages if necessary including the topicc, namespace, tenant, and persistence of the connection.","ref":"Stargate.Receiver.Processor.html","title":"Stargate.Receiver.Processor","type":"module"},{"doc":"Starts a Stargate.Receiver.Processor GenStage process and links it to the calling process. Passes the configuration from the supervisors to the stage to initialize its state and setup subscription to the Stargate.Receiver.Dispatcher producer stage.","ref":"Stargate.Receiver.Processor.html#start_link/1","title":"Stargate.Receiver.Processor.start_link/1","type":"function"},{"doc":"","ref":"Stargate.Receiver.Processor.html#t:raw_message/0","title":"Stargate.Receiver.Processor.raw_message/0","type":"type"},{"doc":"Defines the struct Stargate.Receiver.Processor uses to store its state. Records the name of the process registry, the path parameters (persistence, tenant, namespace, and topic) as well as the handler module defined by the calling application, any init args rrequired for a stateful handler and the state of the handler.","ref":"Stargate.Receiver.Processor.State.html","title":"Stargate.Receiver.Processor.State","type":"module"},{"doc":"Defines the state stored by the consumer or reader websocket process. The Stargate receiver records the registry name associated to its supervision tree, the URL of the cluster and topic it connects to, as well as the individual components that make up the URL including the host, protocol (ws or wss), topic path parameters (persistent or non-persistent, tenant, namespace, and topic) and any query parameters configuing the connection.","ref":"Stargate.Receiver.State.html","title":"Stargate.Receiver.State","type":"module"},{"doc":"Defines a supervisor for the Stargate.Receiver reader and consumer connections and the associated GenStage pipeline for processing and acknowledging messages received on the connection. The top-level Stargate.Supervisor passes the shared connection and :consumer or :reader configurations to the receiver supervisor to delegate management of all receiving processes.","ref":"Stargate.Receiver.Supervisor.html","title":"Stargate.Receiver.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Stargate.Receiver.Supervisor.html#child_spec/1","title":"Stargate.Receiver.Supervisor.child_spec/1","type":"function"},{"doc":"Generates a list of child processes to initialize and start them under the supervisor with a :one_for_all strategy to ensure messages are not dropped if any single stage in the pipeline fails. The processors stage is configurable to a desired number of processes for parallelizing complex or long-running message handling operations.","ref":"Stargate.Receiver.Supervisor.html#init/1","title":"Stargate.Receiver.Supervisor.init/1","type":"function"},{"doc":"Starts a Stargate.Receiver.Supevisor and links it to the calling process.","ref":"Stargate.Receiver.Supervisor.html#start_link/1","title":"Stargate.Receiver.Supervisor.start_link/1","type":"function"},{"doc":"This module defines a top-level supervisor for your Stargate client. It takes a keyword list of configuration values for connecting to the cluster and any producers, readers, or consumers desired, and orchestrates the starting of the process registry and the websocket client(s).","ref":"Stargate.Supervisor.html","title":"Stargate.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Stargate.Supervisor.html#child_spec/1","title":"Stargate.Supervisor.child_spec/1","type":"function"},{"doc":"Creates a Stargate Supervisor and links it to the current process. Pass a keyword list of connection and client information to define the types of websocket connection to establish with the Pulsar cluster. Example opts = [ host : [ { &quot;broker-url.com&quot; , 8080 } ] producer : [ ... producer configs ... ] , consumer : [ ... consumer configs ... ] ] See the Stargate.Producer and Stargate.Receiver modules for the full list of configuration options to each type of client connection.","ref":"Stargate.Supervisor.html#start_link/1","title":"Stargate.Supervisor.start_link/1","type":"function"},{"doc":"Convenience function for working with the Stargate process registry.","ref":"Stargate.Supervisor.html#via/2","title":"Stargate.Supervisor.via/2","type":"function"},{"doc":"","ref":"Stargate.Supervisor.html#t:process_key/0","title":"Stargate.Supervisor.process_key/0","type":"type"},{"doc":"Stargate An Apache Pulsar client written in Elixir using the Pulsar websocket API. Stargate allows you to create producer and consumer connections to a Pulsar cluster and send messages to or receive messages from the cluster. Receivers of messages from Pulsar can be a Reader connection, receiving messages from a topic based on an initial message in the log defined by the user, or via a Consumer connection, receiving all messages on the topic after initial connection. Per Pulsar's documentation, all messages received from a topic are acknowledged by the websocket API, but the Reader acknowledgment is solely to signal to the socket the reader is ready for additional messages, while Consumer acknowledgement will additionally signal to the socket the consumer is ready for the message to be deleted from its subscription. Stargate receivers must supply a message handler module to tell Stargate how to handle messages received from the socket. Producers must supply connection settings for a persistent connection or may supply a single URL signifying the desired persistence, tenant, namespace, and topic to produce to when ad hoc produce is desired.","ref":"readme.html","title":"README","type":"extras"},{"doc":"Available in Hex , the package can be installed by adding stargate to your list of dependencies in mix.exs via the Github strategy: def deps do [ { :stargate , &quot;~&gt; 0.1.0&quot; } ] end The docs can be found at https://hexdocs.pm/stargate .","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"Locating Processes Under the hood, Stargate uses the Registry module to create a via-tuple name for each process within a Stargate- managed supervision tree. The intended API is to create a top-level Stargate.Supervisor and attach option producers and receivers under it as needed. When you do this, Stargate creates the top-level supervisor and prepends :sg_sup_\#{name} to the name of the process (defaults to :default ) as well as a Registry named :sg_reg_\#{name} (defaults to :default ). All processes spun up under this pair receive a via-tuple name identified by {via, Registry, {&lt;registry_name&gt;, {&lt;component&gt;, &lt;persistence&gt;, &lt;tenant&gt;, &lt;namespace&gt;, &lt;topic&gt;}}} where component is the type of process ( :producer , :consumer , etc), persistence is either &quot;persistent&quot; or &quot;non-persistent&quot;, and the remaining values are all strings representing the values supplied when creating the topic in Pulsar. To assist in finding the correct process to send messages to, Stargate provides the Stargate.registry_key/4 function as a helper to calculate this via-tuple easily. When supplying the Stargate.registry_key(&lt;tenant&gt;, &lt;namespace&gt;, &lt;topic&gt;) , Stargate assumes you're trying to reach the Producer process as this is the process most likely to be called directly (in conjunction within Stargate.produce/2,3 ), assumes a persistent topic (because Pulsar assumes topics are persistent by default) and assumes the Supervisor and Registry name suffix to be :default . If necessary, you can supply a Keyword List of options to customize the via-tuple returned by Stargate.registry_key/4 with a combination of the arguments :name or :registry , :component , :persistence . iex&gt; Stargate . registry_key ( &quot;foo&quot; , &quot;bar&quot; , &quot;baz&quot; ) { :via , Registry , { :sg_reg_default , { :producer , &quot;persistent&quot; , &quot;foo&quot; , &quot;bar&quot; , &quot;baz&quot; } } } iex&gt; Stargate . registry ( &quot;foo&quot; , &quot;bar&quot; , &quot;baz&quot; , name : :custom , persistence : &quot;non-persistent&quot; , component : :consumer ) { :via , Registry , { :sg_reg_custom , { :consumer , &quot;non-persistent&quot; , &quot;foo&quot; , &quot;bar&quot; , &quot;baz&quot; } } } Produce Producing to Pulsar via Stargate is as simple as passing an Erlang term to the produce function. Stargate takes care of encoding the message payload with the necessary fields and format required by Pulsar with options to specify certain fields as fits the users' specific needs (see below). To ad hoc produce to Pulsar via Stargate, call Stargate.produce(url, [message]) where url is something like ws://cluster-url:8080/ws/v2/producer/:persistence/:tenant/:namespace/:topic&quot; and [message] is a single message or a list of messages which can be one of: a string-keyed map containing the &quot;payload&quot; key and optionally the &quot;context&quot; key if a specific message context is desired (Stargate uses the &quot;context&quot; for tracking receipt of produced messages by the cluster). A two-element tuple containing a key as the first element and a payload as the second. A message payload only Stargate will clean up the producer processes once the produce has completed. For persistent producer connections to the cluster, you may also start a supervised tree of processes including the socket producer itself and an acknowledger, the job of which is to ensure receipt of messages by the cluster. To start a supervised producer, call something like the following within your application: opts = [ name : :my_producer , optional \\\\ default :default host : [ &quot;example.com&quot; : 8080 ] , protocol : &quot;ws&quot; , optional \\\\ default ws producer : [ persistence : &quot;persistent&quot; , optional \\\\ default persistent tenant : &quot;public&quot; , namespace : &quot;default&quot; , topic : &quot;foo&quot; , query_params : %{ all query params are optional name : &quot;summer&quot; , send_timeout : 30_000 , \\\\ default 30_000 batch_enabled : true , \\\\ default false batch_max_msg : 1_000 , \\\\ default 1_000 max_pending_msg : 1_000 , \\\\ default 1_000 batch_max_delay : 25 , \\\\ default 10 routing_mode : :round_robin , \\\\ ( deprecated by Pulsar ) options :round_robin | :single compression_type : :lz4 , \\\\ default uncompressed , options :lz4 | :zlib producer_name : &quot;myapp-producer&quot; , initial_seq_id : 100 , hashing_scheme : :murmur3 \\\\ options :java_string | :murmur3 } ] ] Stargate.Supervisor . start_link ( opts ) By default, the Stargate.produce/2 will block until it receives acknowledgement the message has successfully been produced to the cluster. To ackowledge produce operations in a non-blocking manner, you may also use Stargate.produce/3 and pass an MFA tuple as the third argument instructing the acknowledger which module, function, and arguments to execute upon receipt of acknowledgement from Pulsar that the produce succeeded. Receive (Consume/Read) To consume messages from Pulsar via Stargate, your application needs to create a consumer or reader process by calling something like the following: opts = [ name : :my_reader , optional \\\\ default :default host : [ &quot;example.com&quot; : 8080 ] , protocol : &quot;ws&quot; , optional \\\\ default ws reader : [ persistence : &quot;persistent&quot; , optional \\\\ default persistent tenant : &quot;public&quot; , namespace : &quot;default&quot; , topic : &quot;foo&quot; , processors : 3 , optional \\\\ default 1 handler : MyApp.Reader.Handler , handler_init_args : [ ] optional \\\\ default [ ] query_params : %{ all query params are optional queue_size : 1_000 , \\\\ default 1_000 name : &quot;morty&quot; , starting_message : :latest \\\\ default :latest , options :latest | :earliest | &quot;some-message-id&quot; } ] ] opts = [ name : :my_consumer , optional \\\\ default :default host : [ &quot;example.com&quot; : 8080 ] , protocol : &quot;ws&quot; , optional \\\\ default ws consumer : [ persistence : &quot;persistent&quot; , optional \\\\ default persistent tenant : &quot;public&quot; , namespace : &quot;default&quot; , topic : &quot;foo&quot; , subscription : &quot;my-app&quot; , processors : 3 , optional \\\\ default 1 handler : MyApp.Reader.Handler , handler_init_args : [ ] optional \\\\ default [ ] query_params : %{ all query params are optional subscription_type : :shared , \\\\ default :exclusive ack_timeout : 100 , \\\\ default 0 queue_size : 1_000 , \\\\ default 1_000 name : &quot;rick&quot; , priority : 10 , max_redeliver_count : 10 , \\\\ default 0 dead_letter_topic : &quot;ricks-dlq&quot; , \\\\ default &quot;{topic}-{subscription}-DLQ&quot; pull_mode : true \\\\ default false } ] ] Stargate.Supervisor . start_link ( opts ) Stargate's receivers are implemented using GenStage to allow for the message processing (the processes that actually call your handler function on messages received) to be parallelized as well as to backpressure into the cluster when setting your consumer connection to pull_mode: true . Producing AND Receiving Starting producers and consumer can but need not require different supervision trees. If your application is a link in a chain that will both receive and produce to the same cluster, you can start a single supervisor with keys for both the receiver and producer configs in the options passed to the Stargate.Supervisor.start_link/1 function. As an example, the configuration below would start a Stargate Supervisor that will manage processes that both monitor an hypothetical company's internal R&amp;D topic publishing application features ready for release and then turn around and produce messages about those feature messages to the application marketing team's topic for public consumption. options = [ name : :pulsar_app , host : [ { :&quot;example.com&quot; , 8080 } ] , producer : [ persistence : &quot;non-persistent&quot; , tenant : &quot;marketing&quot; , namespace : &quot;public&quot; , topic : &quot;new-stuff&quot; ] consumer : [ tenant : &quot;internal&quot; , namespace : &quot;research&quot; , topic : &quot;ready-to-release&quot; , subscription : &quot;rss-feed&quot; , handler : Publicizer.MessageHandler ] ] Stargate.Supervisor . start_link ( options ) Security Stargate supports client security in two ways: by allowing TLS encryption of the connection between the client and the Pulsar cluster, and by JWT token authentication of the Websocket connection. In order to allow TLS encryption of the websocket connection, the URL to the cluster must be over the secure port (Pulsar defaults to 8443) and using the wss:// prefix instead of the plaintext ws:// . To pass custom certificates, to the client connection, include the following in the init options passed to the producer or receiver connection: options = [ ... ssl_options : [ cacertfile : &quot;/certificates/cacert.pem&quot; , certfile : &quot;/certificates/cert.pem&quot; , keyfile : &quot;/certificates/key.pem&quot; ] , ... ] In order to pass a JWT token for authentication, include the following in your connection options for either the producer or receiver process when starting the process. options = [ ... auth_token : &quot;some-jwt-token-string&quot; , ... ] Receiving Messages The message handler module passed to a receiver is expected to implement the Stargate.Receiver.MessageHandler behaviour which includes an optional init/1 if your message handler is expected to track state across messages received from the topic and handle_message/1 , handle_message/2 where handle_message/1 receives only a message while handle_message/2 receives a message and the state being tracked across all messages handled. Including use Stargate.Receiver.MessageHandler in your handler module will created default implementations of these functions that can be overridden as needed. handle_message/1 is expected to return either :ack or :continue while handle_message/2 is expected to return {:ack, state} or {:continue, state} Messages received by Stargate are automatically converted to a %Stargate.Message{} struct by the time they reach the message handler module. This struct contains all the information about where the message came from (topic, namespace, tenant, and persistence) as well as the message identifier assigned to it by the Pulsar cluster, the key if one was supplied, any properties (key/value pairs) attached to the message by the producer, the timestamp the message was published by the cluster as an Elixir DateTime struct and of course the message payload decoded from the Base64 encoding received from Pulsar.","ref":"readme.html#usage","title":"README - Usage","type":"extras"},{"doc":"Cumulative acknowledgement At present, Apache Pulsar does not support cumulative acknowledgement of messages via the websocket API. When this is supported (PR forthcoming with the upstream project), Stargate will be updated to include this as an optional ack strategy for faster processing of large groups of messages. Custom topic configuration and administrative functionality At the time of initial release, Stargate only provides functionality for producing to and receiving (reading or consuming) from Pulsar topics. Pulsar allows for automatically creating single-partition topics within existing tenants and namespaces. While Pulsar provides a RESTful management API, Stargate does not currently provide any functions for interacting with this API. This is a planned expansion of Stargate functionality with the intent that management of tenants, namespaces, and topics can all be accomplished natively from Stargate modules. Stay tuned!","ref":"readme.html#limitations","title":"README - Limitations","type":"extras"},{"doc":"Testing Stargate uses the divo and the plugin divo_pulsar for integration testing, using Docker to stand up a single-node Pulsar &quot;cluster&quot; in standalone mode for testing. See the documentation on the divo and divo_pulsar hex packages for further details. Pulsar For additional information on Pulsar, including configuring and running a cluster, see the project's official documentation .","ref":"readme.html#additional-information","title":"README - Additional information","type":"extras"}]